#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <math.h>

#define CHANNEL 0
#define CHANNEL2 1
#define FW  1
#define BW  0
#define DELAY 5
#define TESTDELAY 500

// Global variables
unsigned char adc_data;


/*configure ADC and ENABLE*/
void setup_adc(){

	
	ADMUX = (1<<REFS0) | (1 << ADLAR);
	ADMUX &= ~(1<<REFS1);
	ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);
	ADCSRA &= ~(1<<ADIE);
}

/*get info from ADC*/
int get_adc(uint8_t channel){
	ADMUX &= 0xE0;
	ADMUX |= channel;
	ADCSRA |= (1<<ADSC);
	loop_until_bit_is_set(ADCSRA, ADIF);	
	return ADCH;
}

void setup_motor(){
	
	
	TCCR1A = _BV(WGM10) |_BV(COM1B1) | _BV(COM1A1) ;
	TCCR1B = _BV(CS12) | _BV(CS10) | _BV(WGM12);
	
	
	DDRD = 0xFF;
}



void drive(int v1, int v2)
{
	/*dreapta */
	OCR1A = abs(v1) & 0xFF;
	if(v1 >= 0)
	{
		PORTD = _BV(PD7);
	}
	else
	{
		PORTD = ~_BV(PD7);
	}
	
	/*stanga*/
	OCR1B = abs(v2) & 0xFF;
	if(v2 >= 0)
	{
		PORTD &= ~_BV(PD6);
	}
	else
	{
		PORTD |= _BV(PD6);
	}
	_delay_ms(DELAY);
}




// ***********************************************************
// Main program
// ***********************************************************
int main(void) {
	
	int i;
	int sens, nr1, med, last_med = 0;
	int adece;
	unsigned char pc;
	DDRA = 0x00;
	DDRC = 0x00;
	DDRD = 0xFF;
	setup_motor();
	setup_adc(); 
	drive(0, 0);
	while(1){	
		adece = get_adc(CHANNEL);
		sens = 0, nr1 = 0;
		for(i = 0; i < 8; ++i)
		{
			pc |= (((PINC &(1 << i)) >> i) << (7 - i));
			nr1+=(((1 << i)&PINC)>>i);
			sens += 10 * (i + 1) * (((1 << i)&PINC)>>i);
		}
		if (nr1 == 0)
		{
			med = 0;
		}
		else
		{
			med = sens/nr1;
		}		
		if(med > 50)
		{
			drive(adece, adece - 2*(med - 45)*adece/35);
			continue;
		}
		else
		{
			if(med < 40 && med != 0)
			{
				drive(adece - 2*(45 - med) * adece / 35, adece);
				continue;
			}
			else
			{
				if(med >= 40 && med <= 50)
				{
					drive(adece, adece);
					continue;
				}
				else
				{
					continue;
					if(last_med > 50)
					{
						drive(adece, adece - (last_med - 45)*adece/45);
						continue;
					}
					else
					{
						if(last_med < 40 && last_med != 0)
						{
							drive(adece - (45 - last_med) * adece / 45, adece);
							continue;
						}
						else
						{
							if(last_med >= 40 && last_med <= 50)
							{
								drive(adece, adece);
								continue;
							}
						}
					}
				}
			}
		}
		if(med != 0)
		{
			last_med = med;
		}			
	}	
		
		
		
}
